package org.cocktail.feve.components.fichedeposte;

// Generated by the WOLips TemplateEngine Plug-in at 14 nov. 2005 12:12:59

import org.cocktail.feve.components.common.FeveWebComponent;
import org.cocktail.fwkcktlgrh.common.metier.EOAffectationDetail;
import org.cocktail.fwkcktlgrh.common.metier.EOChangementPosition;
import org.cocktail.fwkcktlgrh.common.metier.EOContrat;
import org.cocktail.fwkcktlgrh.common.metier.EOModalitesService;
import org.cocktail.fwkcktlgrh.common.metier.services.IndividuGrhService;
import org.cocktail.fwkcktlgrh.common.metier.util.UtilFiche;
import org.cocktail.fwkcktlpersonne.common.metier.EOIndividu;
import org.cocktail.fwkcktlpersonne.common.metier.EORne;
import org.cocktail.fwkcktlwebapp.common.util.DateCtrl;

import com.webobjects.appserver.WOComponent;
import com.webobjects.appserver.WOContext;
import com.webobjects.eocontrol.EOQualifier;
import com.webobjects.foundation.NSArray;
import com.webobjects.foundation.NSDictionary;
import com.webobjects.foundation.NSTimestamp;

public class CompFicheDePosteAgent extends FeveWebComponent {

	// variables entrantes
	private UtilFiche inputLaFicheDePoste;
	private UtilFiche inputLaFicheDePostePrecedente;

	// les occupants / l'occupant en cours
	private NSArray lesOccupations;
	private EOAffectationDetail lOccupationEnCours;
	private NSDictionary leDicoOccupationEnCours;
	private Integer indexOccupationEnCours;

	// element de repetition
	public EOIndividu unIndividu;

	public CompFicheDePosteAgent(WOContext context) {
		super(context);
	}

	// setter

	/**
	 * detection du changement du point d'entree -> RAZ
	 */
	public void setInputLaFicheDePoste(UtilFiche value) {
		inputLaFicheDePostePrecedente = inputLaFicheDePoste;
		inputLaFicheDePoste = value;
		// cas special : il faut pouvoir detecter que
		// les occupations sont differentes
		boolean resetAll = false;
		if (inputLaFicheDePoste != inputLaFicheDePostePrecedente) {
			resetAll = true;
		}
		if (!resetAll && inputLaFicheDePoste != null && inputLaFicheDePoste == inputLaFicheDePostePrecedente) {
			NSArray newOccupations = inputLaFicheDePoste.tosAffectationDetail();
			if (lesOccupations().count() != newOccupations.count())
				resetAll = true;
			if (!resetAll) {
				for (int i = 0; i < lesOccupations().count(); i++) {
					EOAffectationDetail occ = (EOAffectationDetail) lesOccupations().objectAtIndex(i);
					if (!newOccupations.containsObject(occ)) {
						resetAll = true;
						break;
					}
				}
				for (int i = 0; i < newOccupations.count(); i++) {
					EOAffectationDetail occ = (EOAffectationDetail) newOccupations.objectAtIndex(i);
					if (!lesOccupations().containsObject(occ)) {
						resetAll = true;
						break;
					}
				}
			}
		}
		if (resetAll) {
			lOccupationEnCours = null;
			lesOccupations = null;
			leDicoOccupationEnCours = null;
			indexOccupationEnCours = null;
		}
	}

	// getters

	public UtilFiche inputLaFicheDePoste() {
		return inputLaFicheDePoste;
	}

	/**
	 * dico d'infos GEPETO de l'occupant en cours
	 */
	public NSDictionary leDicoIndividuEnCours() {
		if (leDicoOccupationEnCours == null) {
			if (getLOccupationEnCours() != null)
			{
				IndividuGrhService individuService = new IndividuGrhService();	
				leDicoOccupationEnCours = individuService.findDicoAgentGepetoInContext(ec, getLOccupationEnCours());
			}
		}
		return leDicoOccupationEnCours;
	}

	/**
	 * Toutes les occupations (affectation_detail) attachees au poste
	 */
	public NSArray lesOccupations() {
		if (lesOccupations == null)
			lesOccupations = inputLaFicheDePoste.tosAffectationDetail();
		return lesOccupations;
	}

	public EOAffectationDetail getLOccupationEnCours() {
		if (lOccupationEnCours == null && hasOccupations()) {
			lOccupationEnCours = inputLaFicheDePoste().toAffectationDetailActuelleSinonDerniere();
		}
		return lOccupationEnCours;
	}

	/**
	 * Indique si le poste a deja eu des occupations
	 */
	public boolean hasOccupations() {
		return lesOccupations() != null && lesOccupations().count() > 0;
	}

	public int indexOccupantEnCoursAffichage() {
		return indexOccupationEnCours().intValue() + 1;
	}

	private Integer indexOccupationEnCours() {
		if (indexOccupationEnCours == null) {
			indexOccupationEnCours = new Integer(0);
			if (getLOccupationEnCours() != null) {
				indexOccupationEnCours = new Integer(lesOccupations().indexOfIdenticalObject(getLOccupationEnCours()));
			}
		}
		return indexOccupationEnCours;
	}

	// methodes de navigation

	public WOComponent avanceOccupant() {
		if (indexOccupationEnCours().intValue() < lesOccupations().count() - 1) {
			lOccupationEnCours = (EOAffectationDetail) lesOccupations().objectAtIndex(indexOccupationEnCours().intValue() + 1);
			leDicoOccupationEnCours = null;
			indexOccupationEnCours = null;
		}
		return neFaitRien();
	}

	public WOComponent reculeOccupant() {
		if (indexOccupationEnCours().intValue() > 0) {
			lOccupationEnCours = (EOAffectationDetail) lesOccupations().objectAtIndex(indexOccupationEnCours().intValue() - 1);
			leDicoOccupationEnCours = null;
			indexOccupationEnCours = null;
		}
		return neFaitRien();
	}

	// boolean interface

	public boolean showLienAvance() {
		return indexOccupationEnCours().intValue() < lesOccupations().count() - 1;
	}

	public boolean showLienRecule() {
		return indexOccupationEnCours().intValue() > 0;
	}

	public boolean isLOccupationEnCoursExiste() {
		return getLOccupationEnCours() != null;
	}

	// photo

	public boolean lIndividuEnCoursExiste() {
		return getLOccupationEnCours() != null && lOccupationEnCours.toAffectation().toIndividu() != null;
	}

	// binding sortant : l'occupation selectionnée

	public EOAffectationDetail getEoAffectationDetailSelected() {
		return getLOccupationEnCours();
	}

	public void setEoAffectationDetailSelected(EOAffectationDetail value) {

	}
	


	
	
	
	public int getQuotiteTravail() {
		int result = 100;
		int resultModalite = 100;
		int resultDetachement = 100;
		
		boolean modaliteTrouve = false;
		boolean detachementTrouve = false;
		
		NSTimestamp dateNow = DateCtrl.now();
		
		int affectatonContrat = 100;
		
		NSArray<EOContrat> contrats = EOContrat.contratsActuelsForIndividu(ec, lOccupationEnCours.toAffectation().toIndividu());
		if (contrats.size() > 0 ) {
			if (contrats.get(0).toContratAvenants().size() > 0) {
				affectatonContrat = (contrats.get(0).toContratAvenants().get(0)).numQuotRecrutement();
			}
		}
		
		
		//recherche des modalitées  (temps partielle, congées sans traitement, mi-temps therapetique)
		EOQualifier qualModalite = EOModalitesService.INDIVIDU.eq(lOccupationEnCours.toAffectation().toIndividu());
		NSArray<EOModalitesService> modalites = EOModalitesService.modalitesServiceValidesForIndividu(ec, lOccupationEnCours.toAffectation().toIndividu());
		for (EOModalitesService modalite : modalites) {
			if ((modalite.dateDebut().before(dateNow)) && (modalite.dateFin().after(dateNow))) {
				modaliteTrouve = true;
				resultModalite = modalite.quotite();
			}
		}
		
		//recherche détachement
		EOQualifier qualDetachement = EOChangementPosition.NO_DOSSIER_PERS.eq(lOccupationEnCours.toAffectation().toIndividu().noIndividu());
		NSArray<EOChangementPosition> detachements = EOChangementPosition.fetchAll(ec, qualDetachement, null);
		
		EORne  rneEtab = lOccupationEnCours.toAffectation().toStructure().etablissement().toRne();
		if (rneEtab != null) {
			for (EOChangementPosition detachement : detachements) {
				if (detachement.dDebPosition().before(dateNow) &&  (detachement.dDebPosition().before(dateNow) ||  detachement.dFinPosition().after(dateNow)) ) {
					if (detachement.cPosition().equals("ACTI")) {
					} else {
						if (detachement.toRne() != null) {
							if (detachement.toRne().equals(rneEtab)) {
								//rentrant
								resultDetachement =  detachement.quotitePosition();
								detachementTrouve = true;
							}
						}
						if (detachement.toRneOrigine() != null) {
							if (detachement.toRneOrigine().equals(rneEtab)) {
								//sortant
								resultDetachement = 100 - detachement.quotitePosition();
								detachementTrouve = true;
							}
						}
						if (detachement.lieuPosition() != null) {
							//rentrant
							resultDetachement =  detachement.quotitePosition();
							detachementTrouve = true;
						}
					}
				}
			}
		}
		
		
		//calcul final
		if (!modaliteTrouve && !detachementTrouve) {
			result = affectatonContrat;
		}
		
		if (!modaliteTrouve && detachementTrouve) {
			result = affectatonContrat/100*resultDetachement;
		}
		
		if (modaliteTrouve && !detachementTrouve) {
			result = affectatonContrat/100*resultModalite;
		}
		
		if (modaliteTrouve && detachementTrouve) {
			result = affectatonContrat/100*(resultModalite * resultDetachement)/100;
		}
	
		return result;
	}
	
	
}